\newcommand{\DebianMed}{Debian\ Med\xspace}

\begin{abstract}
  The \DebianMed project started in 2002 with the objective to bring
  free medical software into the focus of users. Those may be IT
  service providers for smaller clinics, the doctors themselves,
  researchers in pre-clinical environments or just skilled enthusiasts
  with an ambition to apply their talents to the biomedical domain.  At
  that time, the communities in computational biology, medical imaging
  and medical informatics already had a number of high-quality Free
  Software solutions. Debian as a Linux distribution provided a solid
  foundation for bringing those products together.  To assure complete
  coverage and harmonic integration, the \DebianMed project was
  initiated to provide a software management infrastructure to improve
  communication among Debian package maintainers, \emph{e.g.} to identify
  missing glue packages to translate data formats or to point out
  conflicts in the naming of binaries.

  Over the past decade, the integrative
  \DebianMed project has proven to have positive effects beyond the scope
  of Debian users.
  Many ties have been established between original software developers
  and Debian package maintainers.  Large development teams started to upload
  their Debian packages directly. That communicated the experience
  of the developers back into the distribution and made medical
  software a constituent member of the Debian distribution.

  The ideas behind the \DebianMed generalised into the concept of
  Debian Pure Blends.  Blends, such as Debian Edu, Debian Science,
  DebiChem (chemistry), Debian GIS, DeMuDi \emph{etc.}, were created
  to provide a targeted appearance of the Debian distribution for
  different domains of applications.  Today, Blend task pages complement
  canonical Debian package listings with additional information
  (e.g. scientific references) and also cover software products
  that are relevant for a given domain, but not yet integrated into
  Debian.  A growing community with continuously improving maintenance
  procedures eases direct contributions to Debian, thus preventing unnecessary
  fractioning of the open-source community, and allow for supporting customised
  versions of Debian, such as \DebianMed, within the Debian ecosystem.
  % the others are inactive enough to not mention them here
\end{abstract}


\section{Introduction}

\subsection{Motivation and purpose of \DebianMed}

The advent of \DebianMed was stimulated by the rise of several
Free Software projects that were addressing a series
of diverse tasks in medical care.
Several of these projects -- albeit initially appearing most promising
-- are now dormant.
A few random examples for interesting projects with no visible release
for longer than five years are:
 \printurl{sourceforge.net/projects/freepm/}{FreePM},
 \printurl{www.txoutcome.org/}{OIO},
 \printurl{sourceforge.net/projects/odontolinux/}{OdontoLinux!}
 which was even included in Debian formerly.
Those failed to follow two basic principles of Free Software: care for a solid user base
and recruit qualified developers from it. This is a difficult task that becomes even more difficult with 
increasing specialisation of software.
% MH: don't think that is necessary
%and a field of application that has its
%focus on something else, \emph{i.e.} the human, than the exchange of information. 

%a field of aptask is one of the
%hardest in the field of health care: there is a much smaller number of
%users for such specific software compared to a web browser or an
%office suite.

With a smaller number of potential contributors, one needs to help
the community as much as possible to develop itself and to develop
a tight relationship with its users. Debian as a Linux distribution already
helps distributing software in a readily usable form. Moreover, modularisation aspects of Debian packaging do not only reduce the complexity of packaging individual software: by allowing to
depend on other packages, it also eases maintenance of the
complete system. For example, due to modularisation, updates and fixes in core libraries
make end-user software upgrades unnecessary most of the time. Performing binary builds
for more supported hardware platforms than any other operating system and extensive quality
assurance guarantee robust performance of deployed Debian systems.
\DebianMed complements the Debian infrastructure with a communication platform
for all involved parties: original software developers, Debian maintainers and
Debian users.

%Obtaining reliable information about all these projects is a big problem
%Some enthusiastic users tried to assemble lists
%of these projects and published these on the web.  While those lists
%are an interesting start they are ultimately not really helpful for
%users: Users just need readily usable programs without having to make efforts to obtain
%and install software.  The idea of \DebianMed was to provide
%not only a list but exactly what users need.

% FIXME: Steffen replaced paragraph which said that there were several
%        link lists to medical software but Debian has something
%        better: ready to install software.  Perhaps mentioning
%        MedFloss.org as a better link list with voting (at)
% 
% MH: Agreed -- this needs some glue to get to the next paragraph
Web search engines pick up the software tools and their descriptions
on the \DebianMed task pages. Beyond mere lists or announcement
sites, \emph{e.g.} Freshmeat.net, any Debian user can almost instantly
start evaluating the software on the local computer.



\subsection{Status of Free Software in health care}

More common programs like a web server, or a mail user agent are
installed on a vast amount of computers and have a very large user
base.  A large use base, in turn increases the likelihood of
attracting skilled programmers that tackle unresolved problems or
general improvements of the software they are using.  This type of
user is extremely valuable to a project, because they can implement
and contribute any modification they need by themselves without having
to rely on a project's manpower.

The fact that a piece of software is needed for one's own work is often
the basic motivation to write Free Software.  Biological software is
frequently developed by scientists themselves, because they are experts
in a particular topic and the development is
inseparable from their research.  Many authors of
such software realise the benefits regarding prestige, feedback and facilitation
of scientific progress that is expected from sharing their
code and thus the field of computational biology is well covered by Free
Software solutions.

There are many ties between adjacent fields of science and also software
developers and users outside of biological research benefit from \DebianMed's
and similar efforts. Mutual interest in neuroimaging software led to the
NeuroDebian project \cite{neurodebian} joining forces with \DebianMed to improve
the coverage of medical imaging software in Debian.  Even if some important
packages like the Bio Image Suite \cite{bioimagesuite:2008} are not yet
packaged for Debian, there is already an extensive coverage of viewers, data
analysis pipelines, and development tools supporting  a variety of data formats
(\emph{e.g.} DICOM, NIfTI) as well as other software products of particular
utility in medical imaging.

Medical health record applications in patient management
are considered essential by most people.
As a starting point GNUmed \cite{gnumed:2008} has been included into Debian.
However, there are numerous similar Free Software projects that try to
solve more or less the same problem, but diverge in implementation details
(programming language, database server, etc.), user interface (GUI or
web application) and basic concepts of work flow and philosophy.  It
is planned to also integrate those alternatives that fit Debian's quality
standards and look promising regarding the longevity of the respective project.

Still in the medical section, Debian has also packaged the first open
source pharmaceutical drugs prescriptor and drug-drug interactions
checker FreeDiams \cite{freediams:2010}, which can run on multiple
drugs database (FDA, CA, FR, ZA) as a standalone application or in
connection with other medical health record applications (like for
instance GNUmed).

The even larger task of managing a hospital is also tackled by several
projects, of which the most famous is OpenVista\cite{openvista:2008}. As an
enterprise grade health care information system it is rather
complex and needs a dedicated maintenance team beyond \DebianMed,
with a strong technical background and familiarity with the peculiarities of
OpenVista.  To overcome this problem, the strategy of
\DebianMed is to try to involve the upstream authors into the
packaging.  This has started in August 2009 and we are positive that
we will see OpenVista in Debian at some point in the future.

Another application for hospital management is
OpenMRS\cite{openmrs:2010}, which is in preparation of being included
into Debian and chances are good that this will be finished in the
beginning of 2011.


\section{Principles of Free Software distribution}
% To me this section is more a description of core properties of Debian than
% about principles of Free software distribution. If my impression is wrong
% then many other distributions should be mentioned here as well.

\subsection{Sharing the work -- Debian and cross platform}
% I'm not sure about the purpose of this whole section intro. What does it
% want to say? It starts with Debian as the best possible and ends with
% saying that the actual platform choice doesn't really matter much?

The Debian Project is an association of individuals who share the
intention to create the best possible free operating system.  This
operating system is called Debian GNU/Linux, or simply Debian.
Everybody on the Internet may initiate a site and offer Debian
packages.

To make Free Software development work, it requires a critical mass of
supporters. Development without feedback prior to the submission of
the final product is disadvantageous.  The development of programs is
not the main concern of a regular Linux distribution.  However, with
the focus on Free Software and smooth local compilation, Debian
considerably eases the contribution of comments and concise feedback
of the technically skilled early adopters. Debian helps to bring
developers and users of applications together.

With an increasing abstraction from the underlying hardware, e.g.
via Java or various scripting languages, the actual platform becomes
less of concern. The tools should work on any platform. So, the
remoteness from the core infrastructure that renders keeping the
platform-centric user community difficult, also helps finding
contributors across platforms. The conditions under which those
collaborations are most feasible are summarised in the Debian
Policy and the Debian Free Software Guidelines.


\subsubsection{Debian Free Software Guidelines and Debian Policy}

Free or not free: Debian has a collection of criteria, referred
to as the
\printurl{www.debian.org/social_contract\#guidelines}{Debian
  Free Software Guidelines (DFSG)}, that allow to distinguish free and open source
software from other categories of software.
The most notable of these rules is that a software license must permit
modifications and that those modifications are allowed to be redistributed,
while granting the recipient the same rights. Moreover, there
shall be no restrictions imposed on the recipients to whom those rights
are granted regarding the work that is exerted with that software. 
For example, Debian does not consider software as \textit{free}, if it only comes as
\textit{free for academia}. Such software cannot become part of the Debian
system, but may only by offered in supplemental repositories.

Another important rule is that any granted permission must not be specific to
Debian, but shall be universally applicable to anyone, such as other software
vendors or individual users. This requirement is another indication of an
intrinsic impetus to help Free Software at large.

%The Debian Policy describes the structure and contents of the Debian
%archive and several design issues of the operating system, as well as
%technical requirements that each package must satisfy to be included
%in the distribution.  It makes sure that all different kinds of Free
%Software can coexist on a Debian system.  The conformance of a package
%with Debian Policy can be checked using the program \package{lintian}.

The technical constraints on the packaging are formulated in the Debian
Policy document.  While every package needs to comply with that policy,
every single maintainer of a Debian package has complete freedom
to decide what software to package. Those who package, \emph{i.e.} those
who do, give the distribution it shape.
This is referred to as {\em
do-ocracy} in Debian and refers to the fact that: the one who does something
decides what is done and how it is done.

%% FIXME
%% at: add a more detailed explanation why I finally think that this
%%     paragraph should be kept - but leave it for later versions of
%%     this document
%Usually, maintainers choose software that they use for their
%professional work, for those who use Linux at work. And they are free
%to move the development of Debian in a certain direction (as long as
%they follow the rules of the policy).  For Free Medical Software this
%means that in most cases the developers are health care professionals
%or IT experts working in health care and they just merge their
%professional interest into the progress of Debian.

\subsubsection{Active influence of small groups}

A decision to use the distribution as the main working operating
system can only be made when the user can be as productive as
with an alternative OS. Part of that consideration is the
availability of software that contributes to everyday's routine
and beyond.

This {\em do-ocracy} principle enables individuals or small groups to
actively influence the support of certain fields of work.  
Here, community-driven Linux distributions have an edge over 
commercial Linux distributions. The number of users that may use
a package, \emph{i.e.} that ``pay back'' for an initial packaging effort,
is not the decisive factor in favor of or against the maintenance of a
package. One only needs a sufficiently large community of active
package maintainers to have confidence that the current
infrastructure will be maintained, that new packages will 
be brought into the distribution, and that one will possibly be
allowed to improve current workflows with personal contributions.
\DebianMed is actively benefiting from this aspect and is supporting a
lot of applications that are very specific to medical care and are
not integrated in any other large distribution.

The advantage of plugging Free Medical Software directly into a large
Linux distribution as opposed to creating a separate distribution with a
specific focus on medical care will be further discussed below.

\subsection{Technological infrastructure of Debian}

\subsubsection{Bug tracking system}

Users should be able to give immediate feedback about problems
affecting a software.  While they always have the choice of reporting
these to the upstream developer, usually per email, the
\printurl{www.debian.org/Bugs}{Debian Bug Tracking System} (BTS)
offers an additional channel for tracking software defects
efficiently. The maintainer of a piece of software can investigate
whether a particular report is actually valid before upstream
developers need to deal with it. Moreover, in many cases the Debian
maintainer can suggest or even implement fixes, that are then sent to
upstream alongside the bug report, if the problem is not
Debian-specific.  All problems are made public, and hence the whole
community may contribute to solving a particular issue.

In the case of Free Medical Software the upstream projects frequently
do not feature a bug tracking system.  Thus the inclusion of such
software into Debian adds extra value to the respective projects, because users can
report issues via the Debian BTS and the maintainer of a package
works as a proxy to the software authors.  For a user this has
the benefit of a consistent bug reporting interface and software
authors might get extra technical information provided by the Debian
maintainer who generally has decent technical knowledge.

\subsubsection{Quality Assurance}

Debian has several technical means to assure a constant high level of quality:

\begin{description}
  \item[Autobuilders] There are periodical tests to rebuild all
    software targeting a future release.  This
    verifies compilation against recent build tools and might uncover
    technical problems in software.  This is an additional check
    to the build daemons mentioned below.
  \item[Automated upgrade checks] Before a new version of Debian
    is released, automated tests are done, where every single
    package will be automatically installed into a clean stable system
    of the last published Debian release and then the system will be
    upgraded to the future stable release.  This makes sure that new
    Debian releases can be rolled out smoothly in release critical
    applications.
  \item[Package Installation and De-installation] The tool
    \package{piuparts} tests that .deb packages (as used by Debian)
    handle installation, upgrading, and removal correctly. It does
    this by creating a minimal Debian installation in a chroot, and
    installing, upgrading, and removing packages in that environment,
    and comparing the state of the directory tree before and after.
\end{description}

\subsubsection{Build daemons}

Individual software developers or projects often only have access to a limited
variety of hardware for testing and building their products. The Debian
project, however, automatically compiles software for 13 architectures,
including all widely used platforms for servers, desktops and embedded devices.
To get a package into Debian, be it novel or an update of an existing package,
the maintainer of a package submits the source code of the program together
with his modifications of the code to create a package. The build daemons (or
autobuilders) compile the packages for each of the supported systems and make
the resulting binary package publicly available for download. Logs of the build
platforms are available online for everybody's inspection.



\subsection{Selection of packages}

Debian contains more than 20,000 binary packages, and this number is
constantly increasing.  There is no single user who needs all these
packages.  To specify packages of one's particular interest, several
options are provided by Debian:

\begin{description*}
\item[tasksel] Provision of a reasonable software selection for rather general
  tasks that can be accomplished using a set of packages installed on
  a Debian GNU/Linux system.  However, these are not yet covering
  scientific applications. The Blend toolkit
  will support \command{tasksel} to enable selection of \emph{niche}
  software collections, \emph{e.g.} \DebianMed, right after a fresh installation of a
  general Debian system.

\item[command line package management] \command{apt} and \command{aptitude} provide means to
  search for packages of particular interest by name or words in
  the package's description, or assigned tags like ``works with DICOM''.
  Additionally, every package also lists related packages that, for example,
  enhance its functionality or offer alternative implementations of some
  particular functionality.

% yoh: what about
%    debtags + axi-cache (at)
%    "Similar packages" on packages.debian.org?
% at: yes, needs to be added here and also in Blends documentation (FIXME)

\item[GUI] There are several graphical user interfaces to manipulate
  the installation of packages on a Debian system.  The most
  popular is \command{synaptic}.  It allows users to seek
  for certain packages and to display detailed information about each
  package.
\end{description*}

In addition to its 13 officially supported architectures, there are
ports to even more hardware architectures and operating system kernels.
Moreover, Debian package management and distribution infrastructure
has been adopted to other operating systems lacking a built-in equivalent,
\emph{i.e.} Fink on Mac OS X
(\printurl{fink.sourceforge.net}{fink.sourceforge.net}).

% FIXME
% yoh: context below is not necessary about GNU and even more so
%      not about Linux
% MH: agreed, and moreover if that is mentioned somewhere it should move to
%     very beginning, since we talk about this stuff all the time already
A {\itshape distribution\/} is a collection of software packages.
There are general distributions, which do not have a specific target
user group and try to provide a universal coverage,
and there are several specialised distributions targeting specific groups of users.

{\itshape Distributors\/} are those companies or organisations that are building these
collections of software.  Since the software provided by GNU/Linux distributions
is Free, the user purchasing a copy of the distribution pays for the
service that the distributor is providing.  These services might be:
\begin{itemize*}
  \item Preparing a collection of the software for the target domain of
    use nicely integrated within a uniform environment.
  \item Guaranteeing overall quality of the product and smooth
    installation procedure.
  \item Making software accessible to the users by writing
    documentation to enable the usage of the system with maximum
    effect.
  \item Assuring robust performance with timely software updates and
    security fixes.
  \item Providing technical support and troubleshooting.
  \item Selling installation media and printed documentation.
  \item Offering training and qualification.
\end{itemize*}


\section{Distribution of free medical software}

\subsection{Dedicated bioinformatics and medical distributions}

Between 2003 and 2005 several adapted distributions targeting
bioinformatics and medicine emerged.  Most of them
were based on Knoppix\cite{knopper:2005} (and thus indirectly on Debian).
The motivation behind them was to allow
a small team of not more than five people to release
a product with the following features:
\begin{itemize*}
  \item easy to assemble
  \item tailored for the personal needs of this specific work group
  \item attractive web appearance
\end{itemize*}

Due to the complexity of the task, these projects had to make compromises
regarding the quality of their products and were frequently being
\begin{itemize*}
  \item sloppy about policy of the underlying Debian system
  \item sloppy about the licenses of the included programs
\end{itemize*}

It is hard to estimate the user base of such distributions, but it can
be assumed that they were basically only used inside the institution where
they were developed.
As a consequence, usually not much
effort was invested in setting up a complete support
infrastructure: bug tracking system, active mailing lists,
forums, IRC, etc.

%FIXME: security!

It turned out that this approach is not sustainable for the distribution of
Free Medical Software.
Some of these distributions issued only a single
release, others remained longer but were constantly losing
manpower.  Furthermore, no security updates were made available, and the
distribution of general software tools stagnated at the moment at which
the original fork from Debian, Knoppix or other distribution happened.
Especially the latter aspect made such an approach to distribute software
unacceptable for sensible medical data.

To prevent these problems, \DebianMed took a different approach.  The initial team was
also quite small, but has grown in the eight years of its existence to more
than 20 active maintainers.  The primary idea is to maintain medical
applications {\em inside} Debian.  This automatically solves all
drawbacks of the separate distributions mentioned above: security
updates are provided without any specific effort of the Debian
Med team.  There is a huge and reliable infrastructure with a bug
tracking system, several FTP servers all over the world, autobuilders
and an QA team running intense tests regarding software quality (see
above).

An effort similar to \DebianMed exists in Fedora as
\printurl{fedoraproject.org/wiki/SIGs/FedoraMedical}{FedoraMedical
  SIG (Special Interest Group)} and in openSUSE as
\printurl{en.opensuse.org/Portal:Medical}{openSUSE Medical}.
Both projects share the same idea of putting medical applications inside a
larger distribution instead of trying to do the work of the
distributor themselves.  The
difference with \DebianMed (besides of being different distributions) is
that both teams are much smaller and thus the number of packaged
applications is in both cases less than 5\% of the applications
available for Debian.  Moreover Debian does not distinguish between
a core distribution and optional extensions. Consequently, a full
Debian distribution on whatever medium also automatically contains all medical
applications as well.

Looking beyond Linux distributions there is also FreeBSD.  The ports
collection also contains a versatile
\printurl{www.freebsd.org/ports/biology.html}{collection of
  biological software}.  The remarkable fact here is not the
underlying operating system (you can easily have Debian with a FreeBSD
kernel with Debian 6.0) but rather the fact that the same strategy to
support a specific field as in \DebianMed was followed:  Use a large
and technically well supported system and put the specific software
for special use cases {\em into} this system instead of deriving a
whole {\em new} system from the existing one.


\subsection{Comparison with \DebianMed}

\subsubsection{Other fields than only biology}

Looking at all efforts mentioned above (except Fedora
Medical and openSUSE Medical) it becomes evident that they are all
limited to biological software.  Previously it was stated that one
strong column of \DebianMed is this specific field. This is the case for a specific
reason: The amount of free biological software is large and most of
these projects are relatively easy to turn into packages -- therefore the
amount of work per package is much smaller compared to, for instance,
medical record applications with preparation of databases, dedicated
user management.

There is one major difference between the projects mentioned above
and \DebianMed: While the biological part is really interesting for
medical care, \DebianMed tries to cover all other fields of medical
care as well.  This goal is not yet reached but work in this direction
is continuously performed and some important steps are done.

\subsubsection{Debian Pure Blend}

An even more important difference than the more general approach
compared to the other repositories, is the fact that \DebianMed is not
only about just packaging software.  The \DebianMed project is one of
the earliest so called {\em Debian Pure Blends} and aims to do
more for the comfort of their users than adding binary packages to the
Debian package pool.  The main goal is to turn Debian into the
distribution of choice for people working in the field of medicine and
to make Debian an operating system that is particularly well suited for
the requirements of medical practice and research. The goal of
\DebianMed is a complete system for all tasks in medical care that is
built completely on Free Software.


\subsubsection{Flexibility in supporting small user groups}

On the organisational side the project tries to attract people working
in the field of Free Software in medicine to share the effort of
building a common platform that reduces the amount of work for
developers and users.  Sharing the effort in publishing free medical
software to a large user base is a main advantage of \DebianMed.

The strength of Debian is the huge number of developers (more than
1,000) all over the world working in different fields.  Some of them
are working in the field of biology or medicine and thus have a
natural interest in developing a rock solid system they can rely on
for their own work (not only commercial interest to sell service per
accident).  Often, chances for providing support for
small user groups are greater inside a community driven distribution
than in a commercial distribution: it just needs some developers who
have a specific interest and they will realise and publish an
environment for their needs and will share it with other users.  A
company that has to gain a certain market share is not flexible enough
in this regard to cover very specific interests.

% duplication
The underlying principle that those things will be done if there is
somebody who just does the work is called {\em do-ocracy} -- which
just means the doer decides what gets done.

That is the reason why Debian is often the platform of choice for
researchers in the field of computational biology: Some biologists are Debian
maintainers and so they added support for biological packages. The
more the Debian users in the field of biology report back about
problems or wishes, the more Debian maintainers are able to enhance
their system for their own and their users' benefit.

\subsubsection{Metapackages}

Debian offers tens of thousands of software, data and documentation packages. It is considered
helpful for the users (who might not have the right to install
packages themselves) to specify all biomedical software with a
single instruction given to the local shell or to the local system
administrator.

\DebianMed contains a set of metapackages that
declare dependencies on other Debian packages that can be used to prepare
the system for solving particular tasks.  The user
only needs to search for metapackages starting with prefix \package{med-},
and install just few of them to fulfill his or her software selection requirements.
The package management system then will take care about
the installation of all packages that are in the list of dependencies
of these metapackages -- so the user can be sure that all packages he
or she might need for the job will be installed on his or her system.  If at least one of
the metapackages is installed, a special user menu is created to
enhance usability for the user working in the field of medicine.

Currently, \DebianMed applications are provided in certain
categories: medical practice and patient management, medical research,
hospital information systems, medical imaging, documentation,
molecular biology and medical genetics and others.

%% This sounds somewhat redundant to me - SM
Technically these categories are implemented as appropriate
metapackages, for instance \package{med-bio} for packages concerning
molecular biology and medical genetics and \package{med-practice},
which is helpful to manage a medical practice.  The sense of using
metapackages is that you have to install only a single package using a
package management software tool to get all interesting packages that
are necessary for a single task.  For
instance a single command \\
\hspace*{10mm}\texttt{apt-get install med-bio} \\
results in installation of all applications inside Debian that are
related to the field of molecular biology and medical genetics.


\subsubsection{Continuous growth}

\begin{figure}[!htp]
\centering
\myinsertgraphic{dmstats.pdf}{100mm}{60mm}
\caption{Number of dependencies of selected metapackages}
\label{figure:dmstats}
\end{figure}

Once a piece of software is packaged, the effort needed for its future maintenance is
relatively small. Nevertheless, care is needed not to exhaust initial maintainers'
enthusiasm since continuous maintenance requires investigation of submitted bug reports and following the ``upstream''
development. Also, for many package maintainers, to understand
the upstream code, to learn from it, and to contribute back is a part
of their motivation -- and that often does not scale. In the longer run,
continuous growth can only come through attracting additional contributors
to the Debian project.   Debian welcomes contributions and has set up
\printurl{wiki.debian.org/SponsoredMaintainer}{Sponsored Maintainer} and
\printurl{wiki.debian.org/DebianMaintainer}{Debian Maintainer} programs
to lower the entry barrier.  Those programs allow anyone
to contribute without requiring an official
\printurl{wiki.debian.org/DebianDeveloper}{Debian Developer} status,
obtaining of which requires going through an often lengthy
\printurl{www.debian.org/devel/join/newmaint}{Debian New Maintainer}
process.    Moreover, the Debian policy is not requiring any kind of
a \emph{Contributor Agreement}, thus ownership for any contributed work
remains with the authors, which is an important incentive in the true
spirit of open source.  As a result, anyone
interested can easily contribute and acceptance might be only a couple of emails away.

% FIXME
% Should the Google Code-In and Google Summer of Code be mentioned?
% What else would we have than those Google activities?
% BOSC comes to mind, presentations on FOSDEM etc. Make a paragraph
% of it if you like.
 
%% FIXME
%% sm: one should not say something negative about someone else if 
%%     that is avoidable
%% at: I regard this a {\bf really burning} problem which we need
%%     to address in a paper.  It is not negative to express an
%%     observation
Several Free Software projects which try to deal with small user group
software started with a lot of enthusiasm but at some point in time
developers had other interests or changed their job.  There are just
several reasons why people are not able to continue maintenance of a
project because of lack of man power.

%% FIXME
%% sm: This "within debian" could be interpreted negatively
%% at: why?  I think we should not hide the reason why \DebianMed
%%     is successful.
To make sure the manpower of the team can fully concentrate on the
field of work they really want to do the strategy of \DebianMed is
to stay strictly inside Debian -- so even if the team started with
a few people they were able to relay on a solid technical basis
without extra effort.

Thus \DebianMed is not a derived distribution and is a part of the
Debian project. \DebianMed relies on the core Debian infrastructure
(\emph{e.g.} build farm for a variety of architectures, online
repositories and mirrors, bug tracking system) and only complements it
with an additional thin layer yet again functioning within Debian
infrastructure.  That guarantees that the overall development system
remains robust and does not require extra effort from the \DebianMed
sub-community.  Moreover, adherence to common principles and
organisation helps \DebianMed project members to improve efficiency
and share overall maintenance cost because many actions can be
performed on the entire pool of maintained packages at once.
Admittedly, quite frequently software products maintained by
\DebianMed are of generic utility, such as Java or Python libraries,
and thus of interest to the Debian audience outside of the target
scope of \DebianMed -- Medicine, as a result benefiting Debian as a
whole.
% Due to significant overlap, boundaries between different
%Blends are not clearly defined and the separation of \DebianMed from
%\emph{e.g.} Debian Science is often artifactual.

\begin{figure}[!htp]
\centering
\myinsertgraphic{authorstat.pdf}{100mm}{60mm}
\caption{Activity of most active authors on the \DebianMed mailing list}
\label{figure:authorstats}
\end{figure}

The success of the Debian Blends approach finds evidence in \emph{e.g.} a
continuous growth of the number of packages inside Debian that are of
interest for health care.  Taking the number of dependencies of some
metapackages into account (see figure \ref{figure:dmstats}), only a
small set of packages useful for medical care was available at the
beginning of the \DebianMed project in 2002.  A nearly linear growth
with a gradient that perfectly reflects the availability of programs
in this field can be observed.

Besides the growth of the output of a project it is useful to
characterise the commitment of people involved in the
project.  It is important to ensure that fresh blood is coming into the
project to compensate for the normal loss of supporters,
which always happens in Free Software projects (people find new jobs
with different orientations or have less spare time for private reasons
etc.).  A raw measure for the activity of members might be their mails
to the project mailing list.  Figure \ref{figure:authorstats} shows
the number of mails from the ten most active posters on the \DebianMed
mailing list.  This graph shows that the number of active supporters
was growing constantly in the first years and is now at some constant
level. % yoh: yes -- it is at 10, due to initial selection... ;-)
       % imho either different conclusions are due (# of packages
       % increases, email traffic decreases -- more efficient - more
       % work, less words), or plot should be different to show actually
       % a number of mailing lists participants
% at: We have a lot of projects where the flow of developers is way
%     heavier and they actually lose developers.  We also lost one
%     of the most active posters and thus it is rather 9 despite
%     initial selection.

% I would not show that
% at: I have heard the opinion that specifically that is important
%     for "real" work:  I'm the most active "chatter" (on debian-med)
%     but Charles is much more busy in working (on the development
%     lists - so I think we should leave this
Considering that some technical discussions initiated at \DebianMed
mailing lists quite often naturally migrate to the packaging
list (see Figure \ref{figure:develstats}(a)) the number of postings of
the most active people remained quite constant and only one member of
the team became inactive (while some new people came in but are not
yet visible in the graphs).

\begin{figure}[!htp]
\centering
\footnotesize
\captionsetup{font=small}
\subfigure[]{\myinsertgraphic{authorstat_debian-med-packaging}{60mm}{40mm}}
\subfigure[]{\myinsertgraphic{authorstat_debian-med-commit}{60mm}{40mm}}
\caption{Activity on development list}
\label{figure:develstats}
\end{figure}

The most active people committing packaging materials are shown in
Figure \ref{figure:develstats}(a).  In the last year 26 developers did
1,108 commits to the SVN repository and since the beginning of \DebianMed, 47 developers
did 5,545 commits regarding packaging medical applications or
documentation about the project.

\subsubsection{Backports}

Debian comes in releases. Once a release is out, updates to it are
limited primarily to security-sensitive or grave functionality issues.
New features may introduce regressions and are avoided. That
guarantees a very stable and robust functioning of the system as a
whole. For scientific packages and for
packages reacting to continuous changes in the health care system,
this is not an adequate situation. The long established
\printurl{backports.debian.org}{Debian backports}
service has being integrated within the official Debian project.  It offers updates to
the latest versions of packages while relying on the core components -- whenever
possible -- that were shipped with the official releases. This
compromise allows to brings maximal usability and maximal robustness
together.

\subsubsection{Role inside Debian}

The Debian Pure Blends framework was mainly inspired by the \DebianMed
needs.  The implementation by, for example, the Debian Edu project -- another
Blend -- is far more advanced.  There are several reasons for this
fact.  The main reason is an enormous availability of software for education
and the fact that a Norwegian company paid developers to work full
time on this project.  \DebianMed profited from those
technologies and generalised some tools from Debian Edu for all Blends.
Conversely, inside \DebianMed some new Blend tools were developed which
now enhance the easy preparation of metapackages.

Beyond the metapackages, another service of the Blends is the
so-called web sentinel. It is a web portal to guide the contributors
to the current active tasks (packages) and their associated 
bug reports.
The task pages are providing an overview of all fields of work,
such as biology, medical imaging, practice management, etc., that are
covered by \DebianMed.  The list of all the packages is regenerated
on a daily basis and includes some meta information to \emph{e.g.} point to
relevant scientific publications and the description of the
packages in this task.  The output of the project can be easily
% FIXME at: I just don't understand this remark
%   \marginpar{just have a regular reference to the URL}
viewed at \printurl{debian-med.alioth.debian.org/tasks/}{the
  tasks page of \DebianMed}.

For the comfort of the user these pages are translated (if the
\printurl{ddtp.debian.net/}{Debian Description Translation
  Project} has provided translations), include screenshots from
\printurl{screenshots.debian.net/}{screenshots.debian.net} if
available, give information about the usage of a package by querying
\printurl{popcon.debian.org/}{Debian Popularity Contest}
results and inform about versions packaged for Debian as well as a
notification about new releases.  Moreover, the visitor of
these pages gets an easy option to provide a screenshot or a missing
translation as well as fixing a wrong translation, \emph{i.e.} everyone
is visibly invited to contribute.

There are also quality assurance tools developed; for instance there is
an overview of
\printurl{debian-med.alioth.debian.org/bugs/}{all bugs
  concerning the packages in \DebianMed}.

By providing this kind of tools for other Blends as well \DebianMed
has set a cornerstone in the technical cooperation between user
oriented projects inside Debian.  This in turn awakes the interest of
other Debian developers who might provide other tools for \DebianMed.

\section{Discussion}

The \DebianMed project serves as a common platform for all Free
Software that may be utilised in medical care. Tools developed in
computational biology are just a part of it because they are an important
brick in medical sciences.

The contributors to \DebianMed aim at providing the best possible
platform for medical work. The freedom of users to apply those
technologies for local needs, \emph{e.g.} new scientific problems or
particular regulations in health care, are intrinsically connected
with that prime ambition. The Debian Free Software Guidelines
match those nicely and are applicable across platforms.

Debian is open. It welcomes new members, welcomes new packages
and shares its developments across platforms.


%% FIXME
%% Can this subsection go? openSUSE I do not know, but at least
%% Fedora is just plain excellent in exactly that, too, and it
%% has some other principles from which Debian can learn, still.
%% at: I agree that the content of this paragraph is from pre-Fedora
%%     ages.  I in principle like to propagate the idea but we
%%     need better wording - so drop it for the moment
%
%\subsection{Other distributions}
%
%The Debian GNU/Linux distribution differs from others in several
%ways. Firstly, Debian is a non-commercial organisation of volunteers,
%that does not sell anything. The second and most appealing difference
%is the peer review and continuous pressure among the members to
%provide a high quality of packages. The Debian society has a
%constitution, elects its leader, and transparently describes policies
%for the creation of packages utilising specific technologies.
%
%With these principles, Debian achieved the largest collection
%of ready-to-install Free Software on the Internet.


%
% Could we say what needs to be said here somewhat earlier, possibly?
% I am not sure I want Bio-Linux to be mentioned in this way, with
% whom an active bidirectional collaboration is only developing now
\subsubsection{Importance of community support}

That strong support within the community of users is essential for the
development of software, for quality assurance, feedback on features,
and not at least for the motivation of staff, that all commercial
distributors are well aware of.  For example, Red Hat has initiated
Fedora as a free supplement to their commercial distribution.  This is
the reason why \DebianMed is part of Debian and why groups external to
the Debian society, like Bio-Linux\cite{biolinux:2010}, are also keen
on close collaboration with the community.


\subsubsection{Approaching \DebianMed}

Anybody already using regular Debian or Ubuntu and having a package installed
that is maintained by \DebianMed, is already a user of \DebianMed.
To have a new package shipped with the distribution, one
can ask on the \printurl{lists.debian.org/debian-med}{\DebianMed
    mailing list}. The developers of the software would
be helped with the packaging process and offered guidance towards
self-uploading future versions.

%% FIXME
%% I have difficulties with the remaining items. The style is
%% IMHO not appropriate for a paper and certainly should not be
%% part of the discussion.
%% Not everything should be in Debian but only what can be
%% maintained.
%% at: I'll leave it out only for the 'wrong style' remark.
%%     It is not said that everything should be included - just check
%%     whether something important is missing ... and ask people to
%%     help including it (in turn we should add an item with
%%     suggestions for removals.
%%     I agree that the wording is not appropriate
%\item Check what projects are missing and ask Debian maintainers for
%  official inclusion.  There is a sponsoring program by which even non
%  Debian developers can provide packages which are checked and
%  uploaded by official maintainers.  There is no point in keeping good
%  quality softwares outside of Debian.
%\item \printurl{debian-med.alioth.debian.org/tasks/}{The tasks
%  page of \DebianMed} mentioned above does not only contain the work
%  that was done -- it contains also a nicely formated list which
%  projects would be interesting to reach the final goal to cover each
%  task in medical care with Free Software.  This list inside each
%  section might give some idea where help might be needed.
%\item \halfsloppy Verify whether one needs special configuration for
%  your project.  If yes, verify which possibilities are given in the
%  Debian Pure Blends effort.  It is more than collecting software but
%  bringing the software to your target users while taking the burden
%  from any configuration issues from his back.
%\item The only reason to keep things outside of Debian are licenses
%  which are not compatible with DFSG.  All other parts of your
%  projects can be included and your time for everyday package building
%  tasks can be saved and the workload shared with other people
%  following the same road.
%\end{enumerate*}

\subsection{Developments}

Some scientific funding agencies put considerable pressure on research
grant applicants to explain how to possibly bring their developments
to practical applications, \emph{i.e.} to distribute the
software. Debian and its derivative distributions are a very suitable
medium for this purpose.

\DebianMed hopes to help the communication between developers for the
sharing of data management, \emph{i.e.} the input for their tools that
should be consistent for all tools contributing to a scientific
workflow. While some ideas like \emph{e.g.} getData
\cite{getdata:2010}, have been developed, this still needs to be
amended to suit the community better.

Another aspect is education. Debian or Ubuntu are used in many student
computer labs around the globe with many having packages from
\DebianMed installed. We should hope for the development of courses
that involve Debian packages and those course materials to be shared
similarly to the tools themselves.

\section{Conclusions}

The real use of Free Software for medical care is very heterogeneous,
even if some fields like microbiology are
better covered than others. The continuous updates of data and the
addition of novel important tools for a general medical environment
cannot be performed by a single individual. The adherence to a policy
and the sharing of maintenance are basic technologies to allow
inter-institutional software projects of different kinds in health
care.

Debian and its special dedication to medical software in \DebianMed,
but also the technical infrastructure behind this community project,
renders a comfortable solution.  The volunteers behind \DebianMed
strive to support everybody's specific projects as well as they
possibly can. It is a particular challenge of users of Free
Software, to determine together with the community the available
packages that already serve their needs or may be adapted
respectively.

%% Debian is not important, the Free Software is
%% at: ... and the idea how to distribute niche products of Free
%%     Software is important as well (leave this for FIXME)
%For Debian GNU/Linux to become the race-horse for Free Software in
%health care.

All that said about Debian, at the end of the day it is the freeness
of the software that is important. openSUSE and Fedora, with
slight variations, have adopted much of the principles that Debian
spearheaded. We still need to advance mechanisms like the packaging
format conversion tool \package{alien}
to work together as Free Software users, maybe along
the lines of the collaboration between Debian and Ubuntu. And we all,
users, packagers and developers, need to understand more about cross
platform developments that also includes Mac OS X and Windows.

% FIXME: Should be moved to a "links section" where we also mention
%        MedFloss.org
%Further important software which is listed at
%\printurl{en.wikipedia.org/wiki/List_of_open_source_healthcare_software}{Wikipedia
%  list of open source healthcare software}\cite{wikipediaoslist:2008}
%like for instance OpenVista\cite{openvista:2008} and other enterprise
%grade health care information systems has to be packaged for Debian.

\section{Acknowledgements}

Many thanks go to all contributors to Debian and \DebianMed,
\emph{i.e.}, the providers of the packages, the developers of the Free
Software and to all those who donate the resources for the project.

